diff --git a/src/configure.ac b/src/configure.ac
new file mode 100644
index 0000000..cfaf5de
--- /dev/null
+++ b/src/configure.ac
@@ -0,0 +1,1663 @@
+# Process this file with autoconf to produce a configure script.
+AC_INIT
+AC_PREREQ([2.64])dnl
+AC_REVISION($Revision$)dnl
+AC_USE_SYSTEM_EXTENSIONS
+AC_CONFIG_SRCDIR([screen.c])
+AC_CONFIG_HEADER(config.h)
+
+AC_DEFINE(MAXWIN, 40, [Maximum of simultaneously allowed windows per screen session.])
+AC_DEFINE(SOCKDIR_IS_LOCAL_TO_HOST,,[Define this if the SOCKDIR is not shared between hosts.])
+AC_DEFINE(ALLOW_SYSSCREENRC,1,[
+Screen can look for the environment variable $SYSSCREENRC and -if it
+exists- load the file specified in that variable as global screenrc.
+If you want to enable this feature, define ALLOW_SYSSCREENRC to one (1).
+Otherwise ETCSCREENRC is always loaded.
+])
+AC_DEFINE(CHECKLOGIN,1,[
+Define CHECKLOGIN to force Screen users to enter their Unix password
+in addition to the screen password.
+])
+AH_TEMPLATE([NOSYSLOG],[
+	Define NOSYSLOG if yo do not have logging facilities. Currently
+	syslog() will be used to trace ``su'' commands only.
+	])
+AH_TEMPLATE([PTYMODE],[
+	 define PTYMODE if you do not like the default of 0622, which allows 
+	 public write to your pty.
+	 ])
+AH_TEMPLATE([PTYGROUP],[
+	 define PTYGROUP to some numerical group-id if you do not want the
+	 tty to be in "your" group.
+	 Note, screen is unable to change mode or group of the pty if it
+	 is not installed with sufficient privilege. (e.g. set-uid-root)
+	 ])
+
+AC_DEFINE([DETACH],,[
+	define DETACH can detach a session. An absolute 'must'.
+	])
+
+AC_DEFINE([UTMPOK],,[
+	If screen is installed with permissions to update /etc/utmp (such
+	as if it is installed set-uid root), define UTMPOK.
+	])
+
+AH_TEMPLATE([NETHACK],[
+	As error messages are mostly meaningless to the user, we
+	try to throw out phrases that are somewhat more familiar
+	to ...well, at least familiar to us NetHack players.
+	])
+
+AH_TEMPLATE([CAREFULUTMP],[
+	Set CAREFULUTMP to one (1) if you want that users have at least one
+	window per screen session logged in.
+	])
+
+AC_DEFINE([LOGINDEFAULT],[1],[
+	Set LOGINDEFAULT to one (1)
+	if you want entries added to /etc/utmp by default, else set it to
+	zero (0).
+	LOGINDEFAULT will be one (1) whenever LOGOUTOK is undefined!
+	])
+
+AC_DEFINE([LOGOUTOK],[1],[
+	Set LOGOUTOK to one (1)
+	if you want the user to be able to log her/his windows out.
+	(Meaning: They are there, but not visible in /etc/utmp).
+	Disabling this feature only makes sense if you have a secure /etc/utmp
+	database. 
+	Negative examples: suns usually have a world writable utmp file, 
+	xterm will run perfectly without s-bit.
+
+	If LOGOUTOK is undefined and UTMPOK is defined, all windows are
+	initially and permanently logged in.
+	])
+
+AC_DEFINE([USE_LOCALE],,[
+	Define USE_LOCALE if you want screen to use the locale names
+	for the name of the month and day of the week.
+	])
+ 
+AH_TEMPLATE([USE_PAM],[
+	Define USE_PAM if your system supports PAM (Pluggable Authentication
+	Modules) and you want screen to use it instead of calling crypt().
+	(You may also need to add -lpam to LIBS in the Makefile.)
+	])
+
+
+AH_TEMPLATE([POSIX],[
+	Define POSIX if your system supports IEEE Std 1003.1-1988 (POSIX).
+	])
+
+AH_TEMPLATE([BSDJOBS],[
+	Define BSDJOBS if you have BSD-style job control (both process
+	groups and a tty that deals correctly with them).
+	])
+
+AH_TEMPLATE([TERMIO],[
+	Define TERMIO if you have struct termio instead of struct sgttyb.
+	This is usually the case for SVID systems, where BSD uses sgttyb.
+	POSIX systems should define this anyway, even though they use
+	struct termios.
+	])
+
+AH_TEMPLATE([CYTERMIO],[
+	Define CYTERMIO if you have cyrillic termio modes.
+	])
+
+AH_TEMPLATE([TERMINFO],[
+	Define TERMINFO if your machine emulates the termcap routines
+	with the terminfo database.
+	Thus the .screenrc file is parsed for
+	the command 'terminfo' and not 'termcap'.
+	])
+
+AH_TEMPLATE([NEED_OSPEED],[
+	If your library does not define ospeed, define this.
+	])
+
+AH_TEMPLATE([USESIGSET],[
+	Define USESIGSET if you have sigset for BSD 4.1 reliable signals.
+	])
+
+AH_TEMPLATE([SYSVSIGS],[
+	Define SYSVSIGS if signal handlers must be reinstalled after
+	they have been called.
+	])
+
+AH_TEMPLATE([HAVE_GETUTENT],[
+	If your system has getutent(), pututline(), etc. to write to the
+	utmp file, define HAVE_GETUTENT.
+	])
+
+AH_TEMPLATE([HAVE_STRUCT_UTMP_UT_HOST],[
+	Define HAVE_STRUCT_UTMP_UT_HOST if the utmp file has a host field.
+	])
+
+AH_TEMPLATE([HAVE_UTEMPTER],[
+	Define if you have the utempter utmp helper program
+	])
+
+AH_TEMPLATE([SVR4],[
+	If ttyslot() breaks getlogin() by returning indexes to utmp entries
+	of type DEAD_PROCESS, as it does on SVR4, then our getlogin() 
+	replacement is used.
+	])
+
+AH_TEMPLATE([HAVE_SETEUID],[
+	If your system supports BSD4.4's seteuid() and setegid(), define
+	HAVE_SETEUID.
+	])
+
+AH_TEMPLATE([GETTTYENT],[
+	If your system has the new format /etc/ttys (like 4.3 BSD) and the
+	getttyent(3) library functions, define GETTTYENT.
+	])
+
+AH_TEMPLATE([USEVARARGS],[
+	If your system has vsprintf() and requires the use of the macros in
+	"varargs.h" to use functions with variable arguments,
+	define USEVARARGS.
+	])
+
+AH_TEMPLATE([SELECT_BROKEN],[
+	If the select return value doesn't treat a descriptor that is
+	usable for reading and writing as two hits, define SELECT_BROKEN.
+	])
+
+AH_TEMPLATE([NAMEDPIPE],[
+	Define this if your system supports named pipes.
+	])
+
+AH_TEMPLATE([BROKEN_PIPE],[
+	Define this if your system exits select() immediatly if a pipe is
+	opened read-only and no writer has opened it.
+	])
+
+AH_TEMPLATE([SOCK_NOT_IN_FS],[
+	Define this if the unix-domain socket implementation doesn't
+	create a socket in the filesystem.
+	])
+
+AH_TEMPLATE([USESETENV],[
+	If your system has setenv() and unsetenv() define USESETENV
+	])
+
+AH_TEMPLATE([HAVE_SETENV_3],[
+	If setenv() takes 3 arguments sefine HAVE_SETENV_3
+	])
+
+AH_TEMPLATE([HAVE_SETENV_2],[
+	If setenv() takes 2 arguments sefine HAVE_SETENV_2
+	])
+
+AH_TEMPLATE([NEEDPUTENV],[
+	If your system does not come with a setenv()/putenv()/getenv()
+	functions, you may bring in our own code by defining NEEDPUTENV.
+	])
+
+AH_TEMPLATE([SHADOWPW],[
+	If the passwords are stored in a shadow file and you want the
+	builtin lock to work properly, define SHADOWPW.
+	])
+
+AH_TEMPLATE([HAVE_NL_LANGINFO],[
+	define HAVE_NL_LANGINFO if your system has the nl_langinfo() call
+	and <langinfo.h> defines CODESET.
+	])
+
+AH_TEMPLATE([HAVE_FDWALK],[
+	Newer versions of Solaris include fdwalk, which can greatly improve
+	the startup time of screen; otherwise screen spends a lot of time
+	closing file descriptors.
+	])
+
+AH_TEMPLATE([HAVE_DEV_PTC],[
+	define HAVE_DEV_PTC if you have a /dev/ptc character special
+	device.
+	])
+
+AH_TEMPLATE([HAVE_SVR4_PTYS],[
+	define HAVE_SVR4_PTYS if you have a /dev/ptmx character special
+	device and support the ptsname(), grantpt(), unlockpt() functions.
+	])
+
+AH_TEMPLATE([USEBCOPY],[
+	Define USEBCOPY if the bcopy/memcpy from your system's C library
+	supports the overlapping of source and destination blocks.  When
+	undefined, screen uses its own (probably slower) version of bcopy().
+	])
+AH_TEMPLATE([USEMEMCPY],[
+	SYSV machines may have a working memcpy() -- Oh, this is 
+	quite unlikely. Tell me if you see one.
+	])
+AH_TEMPLATE([USEMEMMOVE],[
+	"But then, memmove() should work, if at all available" he thought...
+	Boing, never say "works everywhere" unless you checked SCO UNIX.
+
+	Their memove fails the test in the configure script. Sigh. (Juergen)
+	])
+
+AH_TEMPLATE([PTYRANGE0],[
+	define PTYRANGE0 and or PTYRANGE1 if you want to adapt screen
+	to unusual environments. E.g. For SunOs the defaults are "qpr" and 
+	"0123456789abcdef". For SunOs 4.1.2 
+	#define PTYRANGE0 "pqrstuvwxyzPQRST" 
+	is recommended by Dan Jacobson.
+	])
+AH_TEMPLATE([PTYRANGE1])
+
+AH_TEMPLATE([HAVE_SETRESUID],[[
+	If your system has the calls setreuid() and setregid(),
+	define HAVE_SETREUID. Otherwise screen will use a forked process to
+	safely create output files without retaining any special privileges.
+	]])
+AH_TEMPLATE([HAVE_SETREUID])
+
+AH_TEMPLATE([POSIX_HAS_A_GOOD_TCSENDBREAK],[
+	Both
+	POSIX_HAS_A_GOOD_TCSENDBREAK and
+	SUNOS4_AND_WE_TRUST_TCSENDBREAK
+	must be defined if you want to favor tcsendbreak over
+	other calls to generate a break condition on serial lines.
+	(Don't bother, if you are not using plain tty windows.)
+	])
+AH_TEMPLATE([SUNOS4_AND_WE_TRUST_TCSENDBREAK],[
+	Both
+	POSIX_HAS_A_GOOD_TCSENDBREAK and
+	SUNOS4_AND_WE_TRUST_TCSENDBREAK
+	must be defined if you want to favor tcsendbreak over
+	other calls to generate a break condition on serial lines.
+	(Don't bother, if you are not using plain tty windows.)
+	])
+AC_DEFINE([POSIX_HAS_A_GOOD_TCSENDBREAK])
+AC_DEFINE([SUNOS4_AND_WE_TRUST_TCSENDBREAK])
+
+
+AC_DEFINE([TTYVMIN], [100],[
+	to lower the interrupt load on the host machine, you may want to
+	adjust the VMIN and VTIME settings used for plain tty windows.
+	See the termio(4) manual page (Non-Canonical Mode Input Processing)
+	for details.
+	if undefined, VMIN=1, VTIME=0 is used as a default - this gives you
+	best user responsiveness, but highest interrupt frequency.
+	(Do not bother, if you are not using plain tty windows.)
+	])
+AC_DEFINE([TTYVTIME],[2],[
+	to lower the interrupt load on the host machine, you may want to
+	adjust the VMIN and VTIME settings used for plain tty windows.
+	See the termio(4) manual page (Non-Canonical Mode Input Processing)
+	for details.
+	if undefined, VMIN=1, VTIME=0 is used as a default - this gives you
+	best user responsiveness, but highest interrupt frequency.
+	(Do not bother, if you are not using plain tty windows.)
+	])
+
+AH_TEMPLATE([LOADAV],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_NUM],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_TYPE],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_SCALE],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_GETLOADAVG],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_UNIX],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_AVENRUN],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+AH_TEMPLATE([LOADAV_USE_NLIST64],[
+	If you want the "time" command to display the current load average
+	define LOADAV. Maybe you must install screen with the needed
+	privileges to read /dev/kmem.
+	])
+
+AH_TEMPLATE([NLIST_DECLARED],[
+	Note that NLIST_ stuff is only checked, when getloadavg() is not available.
+	])
+AH_TEMPLATE([NLIST_STRUCT])
+AH_TEMPLATE([NLIST_NAME_UNION])
+
+AH_TEMPLATE([USE_WAIT2],[
+	On RISCOS we prefer wait2() over wait3(). rouilj@sni-usa.com 
+])
+
+AH_TEMPLATE([SYSV],[
+	Define SYSV if your machine is SYSV complient (Sys V, HPUX, A/UX)
+])
+
+AH_TEMPLATE([_POSIX_SOURCE],[
+	A define to identify a special unix variant
+])
+AH_TEMPLATE([SVR4],[
+	A define to identify a special unix variant
+])
+AH_TEMPLATE([MIPS],[
+	A define to identify a special unix variant
+])
+AH_TEMPLATE([OSX],[
+	A define to identify a special unix variant
+])
+AH_TEMPLATE([ISC],[
+	A define to identify a special unix variant
+])
+AH_TEMPLATE([sysV68],[
+	A define to identify a special unix variant
+])
+# 
+# Define some useful macros
+# 
+AC_DEFUN([AC_PROGRAM_SOURCE],
+[AC_REQUIRE([AC_PROG_CPP])AC_PROVIDE([$0])cat > conftest.c <<EOF
+#include "confdefs.h"
+[$1]
+_CUT_HERE_
+[$2]
+EOF
+eval "$ac_cpp conftest.c 2>&5 | sed -e '1,/_CUT_HERE_/d' -e 's/ //g' > conftest.out"
+. ./conftest.out
+rm -f conftest*
+])dnl
+# 
+define(AC_NOTE,
+[echo "$1" 1>&AS_MESSAGE_FD
+])dnl
+
+# 
+# Extract version from patchlevel.h
+# 
+rev=`sed < ${srcdir}/patchlevel.h -n -e '/#define REV/s/#define REV  *//p'`
+vers=`sed < ${srcdir}/patchlevel.h -n -e '/#define VERS/s/#define VERS  *//p'`
+pat=`sed < ${srcdir}/patchlevel.h -n -e '/#define PATCHLEVEL/s/#define PATCHLEVEL  *//p'`
+VERSION="$rev.$vers.$pat"
+AC_NOTE(this is screen version $VERSION)
+AC_SUBST(VERSION)
+AC_PREFIX_PROGRAM(screen)
+AC_PREFIX_PROGRAM(gzip)
+
+old_CFLAGS="$CFLAGS"
+AC_PROG_CC
+AC_PROG_CPP
+AC_PROG_GCC_TRADITIONAL
+AC_SEARCH_LIBS([strerror],[cposix])
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[main(){return(0);}]])],,[
+if test $CC != cc ; then
+AC_NOTE(Your $CC failed - restarting with CC=cc)
+AC_NOTE()
+CC=cc
+export CC
+exec $0 $configure_args
+fi
+])
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[main(){return(0);}]])],,[exec 5>&2
+eval $ac_link
+AC_NOTE(CC=$CC; CFLAGS=$CFLAGS; LIBS=$LIBS;)
+AC_NOTE($ac_compile)
+AC_MSG_ERROR(cannot run the compiler - sorry)])
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+main()
+{
+  int __something_strange_();
+  __something_strange_(0);
+}
+]])],[AC_MSG_ERROR(Your compiler does not set the exit status - sorry)])
+
+AC_PROG_AWK
+
+AC_PROG_INSTALL
+
+if test -f etc/toolcheck; then
+AC_MSG_NOTICE([checking for buggy tools...])
+sh etc/toolcheck 1>&AS_MESSAGE_FD
+fi
+
+
+
+# SOCKDIR
+AH_TEMPLATE([SOCKDIR],[
+Define SOCKDIR to be the directory to contain the named sockets
+screen creates. This should be in a common subdirectory, such as
+/usr/local or /tmp. It makes things a little more secure if you
+choose a directory which is not writable by everyone or where the
+"sticky" bit is on, but this isn't required.
+If SOCKDIR is not defined screen will put the named sockets in
+the user's home directory. Notice that this can cause you problems
+if some user's HOME directories are AFS- or NFS-mounted. Especially
+AFS is unlikely to support named sockets.
+
+Screen will name the subdirectories "S-$USER" (e.g /tmp/S-davison).
+])
+AC_MSG_CHECKING(if a system-wide socket dir should be used) 
+AC_ARG_ENABLE(socket-dir,
+AS_HELP_STRING([--enable-socket-dir=path],[where to put the per-user sockets])
+AS_HELP_STRING([--disable-socket-dir],[disable system wide socket-dir and use ~/.screen instead]),[sockdir="${enableval}"],[sockdir=yes])
+AS_IF([test x"$sockdir" = xno],[
+	AC_MSG_RESULT(no.  ~/.screen will be used instead.)]
+,
+	AS_IF([test x"$sockdir" = xyes],
+		AC_DEFINE_UNQUOTED(SOCKDIR,
+			[(eff_uid ? "/tmp/uscreens" : "/tmp/screens")])
+		,
+		AC_DEFINE_UNQUOTED(SOCKDIR, 
+			[${sockdir}]))
+	AC_MSG_RESULT(["${sockdir}"]))
+
+# 
+#    ****  special unix variants  ****
+# 
+AC_CHECK_DECL([bsdi],
+AC_DEFINE(TTY_DISABLE_FNBLOCK,,[select barfs without it ...]))
+
+if test -n "$ISC"; then
+  AC_DEFINE(ISC) LIBS="$LIBS -linet"
+fi
+
+if test -f /sysV68 ; then
+AC_DEFINE(sysV68)
+fi
+
+AC_MSG_NOTICE([checking for MIPS...])
+if test -f /lib/libmld.a || test -f /usr/lib/libmld.a || test -f /usr/lib/cmplrs/cc/libmld.a; then
+oldlibs="$LIBS"
+test -f /bin/mx || LIBS="$LIBS -lmld" # for nlist. But not on alpha.
+# djm@eng.umd.edu: "... for one thing, it doubles the size of the executable"
+AC_MSG_NOTICE([checking mld library...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, )],,[LIBS="$oldlibs"])
+# 
+# 
+if test -r /dev/ptc; then
+AC_DEFINE(MIPS)
+AC_MSG_NOTICE([checking wait3...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[wait3();]])],[ ],[
+AC_MSG_NOTICE([checking wait2...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[wait2();]])],
+# John Rouillard (rouilj@sni-usa.com):
+# need -I/usr/include/bsd in RISCOS otherwise sockets are broken, no
+# job control etc.
+# Detect RISCOS if wait2 is present, but not wait3.
+AC_DEFINE(USE_WAIT2) LIBS="$LIBS -lbsd" ; CC="$CC -I/usr/include/bsd"
+)])
+fi
+fi
+
+if test -f /usr/lib/libpyr.a ; then
+oldlibs="$LIBS"
+LIBS="$LIBS -lpyr"
+AC_MSG_NOTICE([checking Pyramid OSX...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[open_controlling_pty("")]])],[AC_DEFINE(OSX)],[LIBS="$oldlibs"])
+fi
+
+AC_MSG_NOTICE([checking for POSIX.1...])
+AC_CHECK_DECL([_POSIX_VERSION],
+	AC_NOTE(- you have a POSIX system) AC_DEFINE(POSIX) posix=1)
+
+AC_MSG_CHECKING([for System V])
+AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
+#include <signal.h>
+#include <fcntl.h>]], [[int x = SIGCHLD | FNDELAY;]])],
+[AC_MSG_RESULT(no)],
+[AC_DEFINE(SYSV) AC_MSG_RESULT(yes)])
+
+AC_MSG_NOTICE([checking for sequent/ptx...])
+AC_CHECK_DECL([_SEQUENT_],
+	LIBS="$LIBS -lsocket -linet";seqptx=1)
+
+oldlibs="$LIBS"
+LIBS="$LIBS -lelf"
+
+AC_MSG_CHECKING([SVR4])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <utmpx.h>]])],[
+	AC_CHECK_HEADER(dwarf.h, AC_DEFINE(SVR4) AC_MSG_RESULT(yes),[
+	 AC_CHECK_HEADER(elf.h, AC_DEFINE(SVR4) AC_MSG_RESULT(yes))])
+	],[LIBS="$oldlibs"; AC_MSG_RESULT(no) ])
+
+AC_CHECK_HEADERS([stropts.h string.h strings.h])
+
+AC_MSG_CHECKING([for Solaris 2.x])
+AC_COMPILE_IFELSE([AC_LANG_PROGRAM(
+     [[#if !defined(SVR4) || !defined(sun)
+      error: This is not Solaris 2.x
+     #endif
+     ]])],
+     [AC_MSG_RESULT(yes); LIBS="$LIBS -lsocket -lnsl -lkstat"],
+     [AC_MSG_RESULT(no)])
+
+# 
+#   ****     Job control     ****
+# 
+AC_CHECK_FUNC(setpgrp)
+
+AC_MSG_CHECKING([BSD job jontrol])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#include <sys/ioctl.h>
+]], [[
+#ifdef POSIX
+tcsetpgrp(0, 0);
+#else
+int x = TIOCSPGRP;
+#ifdef SYSV
+setpgrp();
+#else
+int y = TIOCNOTTY;
+#endif
+#endif
+]])],[AC_MSG_RESULT(you have jobcontrol); AC_DEFINE(BSDJOBS)],[AC_MSG_RESULT(you don't have jobcontrol)])
+
+# 
+#    ****  setresuid(), setreuid(), seteuid()  ****
+# 
+AC_CHECK_FUNCS(setresuid setreuid)
+# 
+# seteuid() check:
+#   linux seteuid was broken before V1.1.11
+#   NeXT, AUX, ISC, and ultrix are still broken (no saved uid support)
+#   Solaris seteuid doesn't change the saved uid, bad for
+#     multiuser screen sessions
+AC_MSG_CHECKING([seteuid])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[
+#if defined(linux) || defined(NeXT) || defined(_AUX_SOURCE) || defined(AUX) || defined(ultrix) || (defined(sun) && defined(SVR4)) || defined(ISC) || defined(sony_news)
+seteuid_is_broken(0);
+#else
+seteuid(0);
+#endif
+]])],
+[AC_MSG_RESULT(yes); AC_DEFINE(HAVE_SETEUID)],
+[AC_MSG_RESULT(no)])
+
+# 
+#    ****  select()  ****
+# 
+AC_MSG_CHECKING([select])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[select(0, 0, 0, 0, 0);]])],
+[AC_MSG_RESULT(yes)],
+[AC_MSG_RESULT(maybe); LIBS="$LIBS -lnet -lnsl"
+AC_MSG_CHECKING([select with $LIBS])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[select(0, 0, 0, 0, 0);]])],
+[AC_MSG_RESULT(yes)],[AC_MSG_ERROR(!!! no select - no screen)])
+])
+
+# 
+#    ****  FIFO tests  ****
+# 
+AC_MSG_CHECKING([fifos])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <sys/types.h>
+#include <unistd.h>
+
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#ifdef POSIX
+/* For select - According to POSIX 1003.1-2001 */
+#include <sys/select.h>
+#else
+/* For select - According to earlier standards */
+#include <sys/time.h>
+#endif
+
+#ifndef O_NONBLOCK
+#define O_NONBLOCK O_NDELAY
+#endif
+#ifndef S_IFIFO
+#define S_IFIFO 0010000
+#endif
+
+char *fin = "/tmp/conftest$$";
+
+main()
+{
+  struct stat stb;
+  fd_set f;
+
+  (void)alarm(5);
+  unlink(fin);
+#ifdef POSIX
+  if (mkfifo(fin, 0777))
+#else
+  if (mknod(fin, S_IFIFO|0777, 0))
+#endif
+    return(1);
+  if (stat(fin, &stb) || (stb.st_mode & S_IFIFO) != S_IFIFO)
+    return(1);
+  close(0);
+#ifdef __386BSD__
+  /*
+   * The next test fails under 386BSD, but screen works using fifos.
+   * Fifos in O_RDWR mode are only used for the BROKEN_PIPE case and for
+   * the select() configuration test.
+   */
+  return(0);
+#endif
+  if (open(fin, O_RDONLY | O_NONBLOCK))
+    return(1);
+  if (fork() == 0)
+    {
+      close(0);
+      if (open(fin, O_WRONLY | O_NONBLOCK))
+	return(1);
+      close(0);
+      if (open(fin, O_WRONLY | O_NONBLOCK))
+	return(1);
+      if (write(0, "TEST", 4) == -1)
+	return(1);
+      return(0);
+    }
+  FD_SET(0, &f);
+  if (select(1, &f, 0, 0, 0) == -1)
+    return(1);
+  return(0);
+}
+]])],[AC_MSG_RESULT(your fifos are usable); fifo=1],[AC_MSG_RESULT(your fifos are not usable)])
+rm -f /tmp/conftest*
+
+if test -n "$fifo"; then
+AC_MSG_CHECKING([for broken fifo implementation])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <sys/types.h>
+#include <unistd.h>
+
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#ifdef POSIX
+/* For select - According to POSIX 1003.1-2001 */
+#include <sys/select.h>
+#else
+/* For select - According to earlier standards */
+#include <sys/time.h>
+#endif
+
+#ifndef O_NONBLOCK
+#define O_NONBLOCK O_NDELAY
+#endif
+#ifndef S_IFIFO
+#define S_IFIFO 0010000
+#endif
+
+char *fin = "/tmp/conftest$$";
+
+main()
+{
+  struct timeval tv;
+  fd_set f;
+
+#ifdef POSIX
+  if (mkfifo(fin, 0600))
+#else
+  if (mknod(fin, S_IFIFO|0600, 0))
+#endif
+    return(1);
+  close(0);
+  if (open(fin, O_RDONLY|O_NONBLOCK))
+    return(1);
+  FD_SET(0, &f);
+  tv.tv_sec = 1;
+  tv.tv_usec = 0;
+  if (select(1, &f, 0, 0, &tv))
+    return(1);
+  return(0);
+}
+]])],[AC_MSG_RESULT(your implementation is ok)],[AC_MSG_RESULT(you have a broken implementation); AC_DEFINE(BROKEN_PIPE) fifobr=1])
+rm -f /tmp/conftest*
+fi
+
+# 
+#    ****  SOCKET tests  ****
+# 
+# 	may need  	LIBS="$LIBS -lsocket" 	here
+# 
+AC_CHECK_HEADERS([sys/uio.h])
+
+AC_MSG_CHECKING([sockets])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <sys/types.h>
+/* For select - According to POSIX 1003.1-2001 */
+#include <sys/select.h>
+/* For select - According to earlier standards */
+#include <sys/time.h>
+#include <unistd.h>
+
+#include <sys/stat.h>
+#include <fcntl.h>
+
+
+#include <sys/socket.h>
+#include <sys/un.h>
+
+#include <sys/socket.h>
+#include <sys/un.h>
+char *son = "/tmp/conftest$$";
+
+main()
+{
+  int s1, s2, l;
+  struct sockaddr_un a;
+  fd_set f;
+
+  (void)alarm(5);
+  if ((s1 = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
+    return(1);
+  a.sun_family = AF_UNIX;
+  strcpy(a.sun_path, son);
+  (void) unlink(son);
+  if (bind(s1, (struct sockaddr *) &a, strlen(son)+2) == -1)
+    return(1);
+  if (listen(s1, 2))
+    return(1);
+  if (fork() == 0)
+    {
+      if ((s2 = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
+	kill(getppid(), 3);
+      (void)connect(s2, (struct sockaddr *)&a, strlen(son) + 2);
+      if (write(s2, "HELLO", 5) == -1)
+	kill(getppid(), 3);
+      return(0);
+    }
+  l = sizeof(a);
+  close(0);
+  if (accept(s1, &a, &l))
+    return(1);
+  FD_SET(0, &f);
+  if (select(1, &f, 0, 0, 0) == -1)
+    return(1);
+  return(0);
+}
+]])],
+[AC_MSG_RESULT(your sockets are usable); sock=1],
+[AC_MSG_RESULT(your sockets are not usable)])
+rm -f /tmp/conftest*
+
+if test -n "$sock"; then
+AC_MSG_CHECKING([socket implementation])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <sys/types.h>
+/* For select - According to POSIX 1003.1-2001 */
+#include <sys/select.h>
+/* For select - According to earlier standards */
+#include <sys/time.h>
+#include <unistd.h>
+
+#include <sys/stat.h>
+#include <fcntl.h>
+
+
+#include <sys/socket.h>
+#include <sys/un.h>
+
+#include <sys/socket.h>
+#include <sys/un.h>
+
+char *son = "/tmp/conftest$$";
+
+main()
+{
+  int s;
+  struct stat stb;
+  struct sockaddr_un a;
+  if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
+    return(0);
+  a.sun_family = AF_UNIX;
+  strcpy(a.sun_path, son);
+  (void) unlink(son);
+  if (bind(s, (struct sockaddr *) &a, strlen(son)+2) == -1)
+    return(0);
+  if (stat(son, &stb))
+    return(1);
+  close(s);
+  return(0);
+}
+]])],[AC_MSG_RESULT(you are normal)],[AC_MSG_RESULT(unix domain sockets are not kept in the filesystem)
+AC_DEFINE(SOCK_NOT_IN_FS) socknofs=1])
+rm -f /tmp/conftest*
+fi
+
+
+# 
+#    ****  choose sockets or fifos  ****
+# 
+if test -n "$fifo"; then
+  if test -n "$sock"; then
+    if test -n "$nore"; then
+      AC_NOTE(- hmmm... better take the fifos)
+      AC_DEFINE(NAMEDPIPE)
+    elif test -n "$fifobr"; then
+      AC_NOTE(- as your fifos are broken lets use the sockets.)
+    else
+      AC_NOTE(- both sockets and fifos usable. let's take sockets.)
+    fi
+  else
+    AC_NOTE(- using named pipes, of course)
+    AC_DEFINE(NAMEDPIPE)
+  fi
+elif test -n "$sock"; then
+  AC_NOTE(- using unix-domain sockets, of course)
+else
+  AC_MSG_ERROR(you have neither usable sockets nor usable pipes -> no screen)
+fi
+
+# 
+#    ****  check the select implementation ****
+# 
+AC_MSG_CHECKING([select return value])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <sys/types.h>
+#include <unistd.h>
+#include <fcntl.h>
+
+char *nam = "/tmp/conftest$$";
+
+#ifdef NAMEDPIPE
+
+#ifndef O_NONBLOCK
+#define O_NONBLOCK O_NDELAY
+#endif
+#ifndef S_IFIFO
+#define S_IFIFO 0010000
+#endif
+
+
+main()
+{
+  fd_set f;
+
+#ifdef __FreeBSD__
+/* From Andrew A. Chernov (ache@astral.msk.su):
+ * opening RDWR fifo fails in BSD 4.4, but select return values are
+ * right.
+ */
+  return(0);
+#endif
+  (void)alarm(5);
+#ifdef POSIX
+  if (mkfifo(nam, 0777))
+#else
+  if (mknod(nam, S_IFIFO|0777, 0))
+#endif
+    return(1);
+  close(0);
+  if (open(nam, O_RDWR | O_NONBLOCK))
+    return(1);
+  if (write(0, "TEST", 4) == -1)
+    return(1);
+
+#else
+
+#include <sys/socket.h>
+#include <sys/un.h>
+
+main()
+{
+  int s1, s2, l;
+  struct sockaddr_un a;
+  fd_set f;
+
+  (void)alarm(5);
+  if ((s1 = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
+    return(1);
+  a.sun_family = AF_UNIX;
+  strcpy(a.sun_path, nam);
+  (void) unlink(nam);
+  if (bind(s1, (struct sockaddr *) &a, strlen(nam)+2) == -1)
+    return(1);
+  if (listen(s1, 2))
+    return(1);
+  if (fork() == 0)
+    {
+      if ((s2 = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
+	kill(getppid(), 3);
+      (void)connect(s2, (struct sockaddr *)&a, strlen(nam) + 2);
+      if (write(s2, "HELLO", 5) == -1)
+	kill(getppid(), 3);
+      return(0);
+    }
+  l = sizeof(a);
+  close(0);
+  if (accept(s1, (struct sockaddr *)&a, &l))
+    return(1);
+#endif
+
+
+  FD_SET(0, &f);
+  if (select(1, &f, 0, 0, 0) == -1)
+    return(1);
+  if (select(1, &f, &f, 0, 0) != 2)
+    return(1);
+  return(0);
+}
+/* } to confort emacs paren matching */
+]])],[AC_MSG_RESULT(select is ok)],[AC_MSG_RESULT(select cannot count); AC_DEFINE(SELECT_BROKEN)])
+
+# 
+#    ****  termcap or terminfo  ****
+# 
+AC_MSG_NOTICE([checking for tgetent...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[tgetent((char *)0, (char *)0);]])],,[
+olibs="$LIBS"
+LIBS="-lcurses $olibs"
+AC_MSG_NOTICE([checking libcurses...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[
+#ifdef __hpux
+__sorry_hpux_libcurses_is_totally_broken_in_10_10();
+#else
+tgetent((char *)0, (char *)0);
+#endif
+]])],,[
+LIBS="-ltermcap $olibs"
+AC_MSG_NOTICE([checking libtermcap...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[tgetent((char *)0, (char *)0);]])],,[
+LIBS="-ltermlib $olibs"
+AC_MSG_NOTICE([checking libtermlib...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[tgetent((char *)0, (char *)0);]])],,[
+LIBS="-lncursesw $olibs"
+AC_MSG_NOTICE([checking libncursesw...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[tgetent((char *)0, (char *)0);]])],,[
+LIBS="-lncurses $olibs"
+AC_MSG_NOTICE([checking libncurses...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[tgetent((char *)0, (char *)0);]])],,[
+AC_MSG_ERROR(!!! no tgetent - no screen)])])])])])])
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+main()
+{
+ char *tgoto(const char *, int, int);
+ return(strcmp(tgoto("%p1%d", 0, 1), "1") ? 0 : 1);
+}]])],[AC_NOTE(- you use the termcap database)],[AC_NOTE(- you use the terminfo database) AC_DEFINE(TERMINFO)])
+AC_MSG_NOTICE([checking ospeed...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[extern short ospeed;]], [[ospeed=5;]])],,[AC_DEFINE(NEED_OSPEED)])
+
+# 
+#    ****  PTY specific things  ****
+# 
+AC_MSG_NOTICE([checking for /dev/ptc...])
+if test -r /dev/ptc; then
+AC_DEFINE(HAVE_DEV_PTC)
+fi
+
+AC_MSG_NOTICE([checking for SVR4 ptys...])
+sysvr4ptys=
+if test -c /dev/ptmx ; then
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[ptsname(0);grantpt(0);unlockpt(0);]])],[AC_DEFINE(HAVE_SVR4_PTYS)
+sysvr4ptys=1])
+fi
+
+AC_CHECK_FUNCS(getpt)
+
+# check for openpty()
+if test -z "$sysvr4ptys"; then
+AC_CHECK_FUNCS(openpty,,
+[AC_CHECK_LIB(util,openpty, [AC_DEFINE(HAVE_OPENPTY)] [LIBS="$LIBS -lutil"])])
+fi
+
+AC_MSG_NOTICE([checking for ptyranges...])
+if test -d /dev/ptym ; then
+pdir='/dev/ptym'
+else
+pdir='/dev'
+fi
+# SCO uses ptyp%d
+AC_EGREP_CPP(yes,
+[#ifdef M_UNIX
+   yes;
+#endif
+], ptys=`echo /dev/ptyp??`, ptys=`echo $pdir/pty??`)
+if test "$ptys" != "$pdir/pty??" ; then
+p0=`echo $ptys | tr ' ' '\012' | sed -e 's/^.*\(.\).$/\1/g' | sort -u | tr -d '\012'`
+p1=`echo $ptys | tr ' ' '\012' | sed -e 's/^.*\(.\)$/\1/g'  | sort -u | tr -d '\012'`
+AC_DEFINE_UNQUOTED(PTYRANGE0,"$p0")
+AC_DEFINE_UNQUOTED(PTYRANGE1,"$p1")
+fi
+
+#    ****  pty mode/group handling ****
+# 
+# support provided by Luke Mewburn <lm@rmit.edu.au>, 931222
+AC_ARG_WITH(pty-mode, [  --with-pty-mode=mode    default mode for ptys], [ ptymode="${withval}" ])
+AC_ARG_WITH(pty-group, [  --with-pty-group=group  default group for ptys], [ ptygrp="${withval}" ])
+test -n "$ptymode" || ptymode=0620
+if test -n "$ptygrp" ; then
+AC_DEFINE_UNQUOTED(PTYMODE, $ptymode)
+AC_DEFINE_UNQUOTED(PTYGROUP,$ptygrp)
+else
+
+AC_MSG_NOTICE([checking default tty permissions/group...])
+rm -f conftest_grp
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <stdio.h>
+main()
+{
+  struct stat sb;
+  char *x,*ttyname();
+  int om, m;
+  FILE *fp;
+
+  if (!(x = ttyname(0))) return(1);
+  if (stat(x, &sb)) return(1);
+  om = sb.st_mode;
+  if (om & 002) return(0);
+  m = system("mesg y");
+  if (m == -1 || m == 127) return(1);
+  if (stat(x, &sb)) return(1);
+  m = sb.st_mode;
+  if (chmod(x, om)) return(1);
+  if (m & 002) return(0);
+  if (sb.st_gid == getgid()) return(1);
+  if (!(fp=fopen("conftest_grp", "w")))
+    return(1);
+  fprintf(fp, "%d\n", sb.st_gid);
+  fclose(fp);
+  return(0);
+}
+]])],[
+    if test -f conftest_grp; then
+	ptygrp=`cat conftest_grp`
+	AC_NOTE([- pty mode: $ptymode, group: $ptygrp])
+	AC_DEFINE_UNQUOTED(PTYMODE, $ptymode)
+	AC_DEFINE_UNQUOTED(PTYGROUP,$ptygrp)
+    else
+	AC_NOTE(- ptys are world accessable)
+    fi
+],[
+    WRITEPATH=''
+    XTERMPATH=''
+    AC_PATH_PROG(WRITEPATH, write)
+    AC_PATH_PROG(XTERMPATH, xterm)
+    found=
+    if test -n "$WRITEPATH$XTERMPATH"; then
+      findfollow=
+      lsfollow=
+      found=`find $WRITEPATH $XTERMPATH -follow -print 2>/dev/null`
+      if test -n "$found"; then
+	findfollow=-follow
+	lsfollow=L
+      fi
+      if test -n "$XTERMPATH"; then
+	ptygrpn=`ls -l$lsfollow $XTERMPATH | sed -n -e 1p | $AWK '{print $4}'`
+	if test tty != "$ptygrpn"; then
+	  XTERMPATH=
+	fi
+      fi
+    fi
+    if test -n "$WRITEPATH$XTERMPATH"; then
+      found=`find $WRITEPATH $XTERMPATH $findfollow -perm -2000 -print` 
+      if test -n "$found"; then
+	ptygrp=`ls -ln$lsfollow $found | sed -n -e 1p | $AWK '{print $4}'`
+	AC_NOTE([- pty mode: $ptymode, group: $ptygrp])
+	AC_DEFINE_UNQUOTED(PTYMODE, $ptymode)
+	AC_DEFINE_UNQUOTED(PTYGROUP,$ptygrp)
+      else
+	AC_NOTE(- ptys are world accessable)
+      fi
+    else
+      AC_NOTE(- cannot determine - assume ptys are world accessable)
+    fi
+  
+])
+rm -f conftest_grp
+fi
+
+# 
+#    ****  utmp handling  ****
+# 
+
+AC_CHECK_DECL([__ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__],[
+# Mac OS X 10.5 still has utmp.h, but they warn it's deprecated
+	AC_DEFINE(_UTMPX_COMPAT,,[Turn on Mac OS X 10.5 UTMP compatibility])
+	AC_CHECK_HEADERS(utmpx.h)
+],[
+	AC_CHECK_HEADERS(utmp.h utmpx.h)
+])
+
+AC_CHECK_DECL([HAVE_UTMP_H],[
+	AC_SEARCH_LIBS(getutent,[gen])
+	AC_CHECK_FUNCS(getutent)
+],[
+	AC_CHECK_DECL([HAVE_UTMPX_H],[
+		AC_CHECK_FUNCS(getutxent,[AC_DEFINE([HAVE_GETUTENT])])
+	])
+])
+
+
+AC_CHECK_MEMBERS([struct utmp.ut_host])
+
+AC_CHECK_HEADER(utempter.h, have_utempter=yes, have_utempter=no)
+if test "$have_utempter" = yes; then
+  AC_DEFINE(HAVE_UTEMPTER)
+  LIBS="$LIBS -lutempter"
+fi
+
+# 
+#    ****  loadav  ****
+# 
+AC_MSG_NOTICE([checking for libutil(s)...])
+test -f /usr/lib/libutils.a && LIBS="$LIBS -lutils"
+test -f /usr/lib/libutil.a && LIBS="$LIBS -lutil"
+
+AC_MSG_NOTICE([checking getloadavg...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(AC_INCLUDES_DEFAULT,[[getloadavg((double *)0, 0);]])],[
+AC_DEFINE(LOADAV_GETLOADAVG) load=1,
+if test -f /usr/lib/libkvm.a ; then
+olibs="$LIBS"
+LIBS="$LIBS -lkvm"
+AC_MSG_NOTICE([checking getloadavg with -lkvm...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(AC_INCLUDES_DEFAULT, [[getloadavg((double *)0, 0);]])],[AC_DEFINE(LOADAV_GETLOADAVG) load=1],[LIBS="$olibs"])
+fi
+])
+
+if test -z "$load" ; then
+AC_EGREP_CPP(yes,
+[#if defined(NeXT) || defined(apollo) || defined(linux)
+  yes;
+#endif
+], load=1)
+fi
+if test -z "$load" ; then
+AC_MSG_NOTICE([checking for kernelfile...])
+for core in /unix /vmunix /dynix /hp-ux /xelos /dev/ksyms /kernel/unix /kernel/genunix /unicos /mach /netbsd /386bsd /dgux /bsd /stand/vmunix; do
+  if test -f $core || test -c $core; then
+    break
+  fi
+done
+if test ! -f $core && test ! -c $core ; then
+  AC_NOTE(- no kernelfile found)
+else
+  AC_NOTE(- using kernelfile '$core')
+  if test -r $core ; then
+  AC_DEFINE_UNQUOTED(LOADAV_UNIX,"$core")
+  AC_CHECK_HEADER(nlist.h,
+    [AC_DEFINE(NLIST_STRUCT)
+     AC_MSG_NOTICE([checking n_un in struct nlist...])
+     AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <nlist.h>]], [[struct nlist n; n.n_un.n_name = 0;]])],[AC_DEFINE(NLIST_NAME_UNION)])])
+
+  AC_MSG_NOTICE([checking for nlist declaration...])
+  AC_EGREP_CPP([nlist(( |	)( |	)*.*\(|\()],[
+#ifdef NLIST_STRUCT
+# include <nlist.h>
+#else
+# include <a.out.h>
+#endif
+],AC_DEFINE(NLIST_DECLARED))
+
+  AC_MSG_NOTICE([checking for avenrun symbol...])
+  nlist64=
+  for av in avenrun _avenrun _Loadavg avenrun _avenrun _Loadavg; do
+  AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#ifdef NLIST_STRUCT
+#include <nlist.h>
+#else
+#include <a.out.h>
+#endif
+
+$nlist64
+
+struct nlist nl[2];
+
+main()
+{
+#if !defined(_AUX_SOURCE) && !defined(AUX)
+# ifdef NLIST_NAME_UNION
+  nl[0].n_un.n_name = "$av";
+# else
+  nl[0].n_name = "$av";
+# endif
+#else
+  strncpy(nl[0].n_name, "$av", sizeof(nl[0].n_name));
+#endif
+  nlist(LOADAV_UNIX, nl);
+  if (nl[0].n_value == 0)
+    return(1);
+  return(0);
+}
+  ]])],[avensym=$av;break])
+  if test "$av" = _Loadavg; then
+    nlist64='#define nlist nlist64'
+  fi
+  done
+  if test -z "$avensym" ; then
+    AC_NOTE(- no avenrun symbol found)
+  else
+    AC_NOTE(- using avenrun symbol '$avensym')
+    AC_DEFINE_UNQUOTED(LOADAV_AVENRUN,"$avensym")
+    if test -n "$nlist64"; then
+      AC_NOTE(- used nlist64 to find it)
+      AC_DEFINE(LOADAV_USE_NLIST64)
+    fi
+    load=1
+  fi
+  else
+    AC_NOTE(  cannot configure the load average display feature)
+    AC_NOTE(  because $core is not readable by you.)
+    AC_NOTE(  To configure the load average display feature)
+    AC_NOTE(  re-run configure as root if possible.)
+    AC_NOTE(  If you are not the system administrator then disregard)
+    AC_NOTE(  this warning.  You can still use screen without)
+    AC_NOTE(  the load average display feature.)
+  fi
+fi
+fi
+
+AC_PROGRAM_SOURCE([
+#include <sys/param.h>
+],[
+#if !defined(LOADAV_GETLOADAVG) && ((defined(hp300) && !defined(__hpux)) || defined(sun) || (defined(ultrix) && defined(mips)) || defined(_SEQUENT_) || defined(sgi) || (defined(SVR4) && !defined(__hpux)) || defined(sony_news) || (!defined(__osf__) && defined(__alpha)) || defined(_IBMR2) || defined(_AUX_SOURCE) || defined(AUX) || defined(m88k))
+loadtype=long
+# if defined(apollo) || defined(_IBMR2) || defined(_AUX_SOURCE) || defined(AUX)
+loadscale=65536
+# else
+#  if defined(FSCALE) && !defined(__osf__)
+#   undef FSCALE
+loadscale=FSCALE
+#  else
+#   ifdef sgi
+loadtype=int
+loadscale=1024
+#   else
+#    if defined(MIPS) || defined(SVR4) || defined(m88k)
+loadscale=256
+#    else /* not MIPS */
+loadscale=1000 	/* our default value */
+#    endif /* MIPS */
+#   endif /* sgi */
+#  endif /* not FSCALE */
+# endif /* not apollo */
+#else
+loadtype=double
+loadscale=1
+#endif
+#ifdef alliant
+loadnum=4
+#else
+loadnum=3
+#endif
+])
+
+if test -n "$load" ; then AC_DEFINE(LOADAV) fi
+if test -n "$loadtype" ; then AC_DEFINE_UNQUOTED(LOADAV_TYPE,$loadtype) fi
+if test -n "$loadnum" ; then AC_DEFINE_UNQUOTED(LOADAV_NUM,$loadnum) fi
+if test -n "$loadscale" ; then AC_DEFINE_UNQUOTED(LOADAV_SCALE,$loadscale) fi
+
+# 
+#    ****  signal handling  ****
+# 
+AC_TYPE_SIGNAL
+if test -n "$posix" ; then
+
+# POSIX has reliable signals with void return type.
+AC_NOTE(assuming posix signal definition)
+
+else
+
+AC_MSG_NOTICE([checking sigset...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#include <signal.h>
+]], [[
+sigset(0, (RETSIGTYPE (*)())0);
+]])],[AC_DEFINE(USESIGSET)])
+AC_MSG_NOTICE([checking signal implementation...])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#include <signal.h>
+
+#ifndef SIGCLD
+#define SIGCLD SIGCHLD
+#endif
+#ifdef USESIGSET
+#define signal sigset
+#endif
+
+int got;
+
+RETSIGTYPE
+hand()
+{
+  got++;
+}
+
+main()
+{
+  /* on hpux we use sigvec to get bsd signals */
+#ifdef __hpux
+  (void)signal(SIGCLD, hand);
+  kill(getpid(), SIGCLD);
+  kill(getpid(), SIGCLD);
+  if (got < 2)
+    return(1);
+#endif
+  return(0);
+}
+]])],,[AC_DEFINE(SYSVSIGS)])
+
+fi
+
+# 
+#    ****  libraries  ****
+# 
+
+AC_MSG_NOTICE([checking for crypt and sec libraries...])
+test -f /lib/libcrypt_d.a || test -f /usr/lib/libcrypt_d.a && LIBS="$LIBS -lcrypt_d"
+oldlibs="$LIBS"
+LIBS="$LIBS -lcrypt"
+AC_MSG_NOTICE([checking crypt...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, )],,[LIBS="$oldlibs"])
+test -f /lib/libsec.a || test -f /usr/lib/libsec.a && LIBS="$LIBS -lsec"
+test -f /lib/libshadow.a || test -f /usr/lib/libshadow.a && LIBS="$LIBS -lshadow"
+oldlibs="$LIBS"
+LIBS="$LIBS -lsun"
+AC_MSG_NOTICE([checking IRIX sun library...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, )],,[LIBS="$oldlibs"])
+
+AC_MSG_NOTICE([checking syslog...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(,[[closelog();]])], , [oldlibs="$LIBS"
+LIBS="$LIBS -lbsd"
+AC_MSG_NOTICE([checking syslog in libbsd.a...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[closelog();]])],[AC_NOTE(- found.)],[LIBS="$oldlibs"
+AC_NOTE(- bad news: syslog missing.) AC_DEFINE(NOSYSLOG)])])
+
+AC_EGREP_CPP(yes,
+[#ifdef M_UNIX
+   yes;
+#endif
+], LIBS="$LIBS -lsocket -lcrypt_i")
+
+# 
+#    ****  misc things  ****
+# 
+AC_HEADER_SYS_WAIT
+
+AC_MSG_NOTICE([checking for termio or termios...])
+AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <termio.h>]])],[AC_DEFINE(TERMIO)],[
+if test -n "$posix"; then
+AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <termios.h>]])],[AC_DEFINE(TERMIO)])
+fi
+])
+
+# AC_CHECK_HEADER(shadow.h, AC_DEFINE(SHADOWPW))
+AC_MSG_NOTICE([checking getspnam...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <shadow.h>]], [[getspnam("x");]])],[AC_DEFINE(SHADOWPW)])
+
+AC_MSG_NOTICE([checking getttyent...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[getttyent();]])],[AC_DEFINE(GETTTYENT)])
+
+AC_MSG_NOTICE([checking fdwalk...])
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[fdwalk(NULL, NULL);]])],[AC_DEFINE(HAVE_FDWALK)])
+
+AC_MSG_NOTICE([checking whether memcpy/memmove/bcopy handles overlapping arguments...])
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+main() {
+  char buf[10];
+  strcpy(buf, "abcdefghi");
+  bcopy(buf, buf + 2, 3);
+  if (strncmp(buf, "ababcf", 6))
+    return(1);
+  strcpy(buf, "abcdefghi");
+  bcopy(buf + 2, buf, 3);
+  if (strncmp(buf, "cdedef", 6))
+    return(1);
+  return(0); /* libc version works properly.  */
+}]])],[AC_DEFINE(USEBCOPY)])
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#define bcopy(s,d,l) memmove(d,s,l)
+main() {
+  char buf[10];
+  strcpy(buf, "abcdefghi");
+  bcopy(buf, buf + 2, 3);
+  if (strncmp(buf, "ababcf", 6))
+    return(1);
+  strcpy(buf, "abcdefghi");
+  bcopy(buf + 2, buf, 3);
+  if (strncmp(buf, "cdedef", 6))
+    return(1);
+  return(0); /* libc version works properly.  */
+}]])],[AC_DEFINE(USEMEMMOVE)])
+
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#define bcopy(s,d,l) memcpy(d,s,l)
+main() {
+  char buf[10];
+  strcpy(buf, "abcdefghi");
+  bcopy(buf, buf + 2, 3);
+  if (strncmp(buf, "ababcf", 6))
+    return(1);
+  strcpy(buf, "abcdefghi");
+  bcopy(buf + 2, buf, 3);
+  if (strncmp(buf, "cdedef", 6))
+    return(1);
+  return(0); /* libc version works properly.  */
+}]])],[AC_DEFINE(USEMEMCPY)])
+
+AC_SYS_LONG_FILE_NAMES
+
+AC_MSG_CHECKING(for vsprintf)
+AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[vsprintf(0,0,0);]])],[AC_MSG_RESULT(yes);AC_DEFINE(USEVARARGS)],[AC_MSG_RESULT(no)])
+
+AC_HEADER_DIRENT
+
+AC_MSG_CHECKING(for setenv)
+if test -z "$ac_setenv_args"; then
+    AC_COMPILE_IFELSE([AC_LANG_PROGRAM(, [[
+        setenv((char *) 0, (char *) 0, 0);
+    ]])],[ac_setenv_args=3])
+fi
+if test -z "$ac_setenv_args"; then
+    AC_COMPILE_IFELSE([AC_LANG_PROGRAM(, [[
+        setenv((char *) 0, (char *) 0);
+    ]])],[ac_setenv_args=2])
+fi
+if test -n "$ac_setenv_args"; then
+    AC_DEFINE(USESETENV)
+    if test "$ac_setenv_args" = 3; then
+        AC_DEFINE(HAVE_SETENV_3)
+    elif test "$ac_setenv_args" = 2; then
+        AC_DEFINE(HAVE_SETENV_2)
+    fi
+else
+    AC_MSG_RESULT(no)
+    AC_MSG_CHECKING(for putenv)
+    AC_LINK_IFELSE([AC_LANG_PROGRAM(, [[putenv((char *)0);unsetenv((char *)0);]])],[AC_MSG_RESULT(yes) ],[AC_MSG_RESULT(no);AC_DEFINE(NEEDPUTENV)])
+fi
+
+AC_MSG_CHECKING([for nl_langinfo(CODESET)])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#include <langinfo.h>
+]], [[nl_langinfo(CODESET);]])],
+[AC_MSG_RESULT(yes);AC_DEFINE(HAVE_NL_LANGINFO)],
+[AC_MSG_RESULT(no)])
+
+AC_SEARCH_LIBS(gethostname, nsl)
+
+AC_CHECK_FUNCS(rename fchmod fchown strerror lstat _exit utimes vsnprintf getcwd setlocale strftime)
+
+AC_ARG_ENABLE(pam,AS_HELP_STRING([--enable-pam],[enable PAM support]))
+if test "$enable_pam" = "yes"; then
+    AC_MSG_CHECKING(for PAM support)
+    oldlibs="$LIBS"
+    LIBS="$LIBS -lpam"
+    AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <security/pam_appl.h>]], [[
+	pam_start(0, 0, 0, 0);
+	pam_authenticate(0, 0);
+	pam_end(0,0);
+    ]])],[AC_MSG_RESULT(yes);AC_DEFINE(USE_PAM)],[AC_MSG_RESULT(no);LIBS="$oldlibs"])
+fi
+
+AC_ARG_ENABLE(use_locale, [  --enable-locale         use localized month/day names])
+if test "$enable_use_locale" = "yes"; then
+  AC_DEFINE(USE_LOCALE)
+fi
+
+AC_DEFUN([MY_ARG_ENABLE],
+            [AH_TEMPLATE([$1],[define $1 $2])
+	     AC_ARG_ENABLE(m4_translit([[$1]], [_A-Z], [-a-z]),
+               [AS_HELP_STRING([--enable-m4_translit([$1], [_A-Z], [-a-z])],
+                               [enable $2])],
+	       AS_IF([test x"${enableval}" != xno ],[AC_DEFINE($1)]))])
+
+MY_ARG_ENABLE([BUILTIN_TELNET],[
+	to add builtin telnet support to screen.
+	Syntax: screen //telnet host [port]
+	])
+MY_ARG_ENABLE([RXVT_OSC],[
+	if you want support for rxvt's special
+	       change fgcolor/bgcolor/bgpicture sequences
+	       (OSC codes)
+	])
+MY_ARG_ENABLE([COLORS256],[for support for 256 colors])
+MY_ARG_ENABLE([MULTI],[to allow multiple attaches.])
+MY_ARG_ENABLE([PTYROFS],[
+	 if the /dev/pty devices are mounted on a read-only 
+	 filesystem so screen should not even attempt to set mode or group  
+	 even if running as root (e.g. on TiVo).
+	 ],)
+MY_ARG_ENABLE([LOCKPTY],[
+	to add this exclusive locking:
+	If screen is NOT installed set-uid root, screen can provide tty
+	security by exclusively locking the ptys.  While this keeps other
+	users from opening your ptys, it also keeps your own subprocesses
+	from being able to open /dev/tty.
+	])
+MY_ARG_ENABLE([TOPSTAT],[
+	if you'd rather see the status line on the first line of your
+	terminal rather than the last.
+	])
+MY_ARG_ENABLE([LOCK],[
+	if you want to use a lock program for a screenlock.
+	])
+MY_ARG_ENABLE([PASSWORD],[
+	for secure reattach of your screen.
+	])
+MY_ARG_ENABLE([COPY_PASTE],[
+	to use the famous hacker's treasure zoo.
+	])
+MY_ARG_ENABLE([REMOTE_DETACH],[
+	(-d option) to move screen between terminals.
+	])
+MY_ARG_ENABLE([POW_DETACH],[
+	to have a detach_and_logout key (requires DETACH).
+	])
+MY_ARG_ENABLE([AUTO_NUKE],[
+	to enable Tim MacKenzies clear screen nuking
+	])
+MY_ARG_ENABLE([PSEUDOS],[
+	to allow window input/output filtering
+	])
+MY_ARG_ENABLE([MULTIUSER],[
+	to allow other users attach to your session
+	(if they are in the acl, of course)
+	])
+MY_ARG_ENABLE([MAPKEYS],[
+	to include input keyboard translation.
+	])
+MY_ARG_ENABLE([FONT],[
+	to support ISO2022/alternet charset support
+	])
+MY_ARG_ENABLE([COLOR],[
+	to include ansi color support. This may expose
+	a bug in x11r6-color-xterm.
+	])
+MY_ARG_ENABLE([DW_CHARS],[
+	to include support for double-width character
+	sets.
+	])
+MY_ARG_ENABLE([ENCODINGS],[
+	to include support for encodings like euc or big5.
+	Needs FONT to work.
+	])
+MY_ARG_ENABLE([UTF8],[
+	if you want support for UTF-8 encoding.
+	Needs FONT and ENCODINGS to work.
+	])
+MY_ARG_ENABLE([COLORS16],[
+	if you want 16 colors.
+	Needs COLOR to work.
+	])
+MY_ARG_ENABLE([ZMODEM],[for built-in ZMODEM support])
+MY_ARG_ENABLE([BLANKER_PRG],[for external screen blanking support])
+MY_ARG_ENABLE([HAVE_BRAILLE],[
+	if you have a braille display.
+	The code inside #ifdef HAVE_BRAILLE was contributed by Hadi Bargi
+	Rangin (bargi@dots.physics.orst.edu).
+	WARNING: this is more or less unsupported code, it may be full of
+	bugs leading to security holes, enable at your own risk!
+	])
+MY_ARG_ENABLE([USRLIMIT],[
+	if UTMPOK is defined and your system (incorrectly) counts logins by
+	counting non-null entries in /etc/utmp (instead of counting non-null
+	entries with no hostname that are not on a pseudo tty), so as
+	to have screen put an upper-limit on the number of entries to write
+	into /etc/utmp.  This helps to keep you from exceeding a limited-user
+	license.
+	])
+MY_ARG_ENABLE([USE_SGR],[
+	if you want screen
+	to switch attributes only with sgr.
+	Some terminals, e.g. Wyse 120, use a bitfield to select attributes.
+	This doesn't work with the standard so/ul/m? terminal entries,
+	because they will cancel each other out. 
+	On TERMINFO machines, "sa" (sgr) may work. 
+	This is *not* recomended, do this only if you must.
+	])
+MY_ARG_ENABLE([CHECK_SCREEN_W],[
+	if you want screen to set TERM to screen-w
+	if the terminal width is greater than 131 columns. No longer needed
+	on modern systems which use $COLUMNS or the tty settings instead.
+	])
+
+
+
+# 
+#    ****  the end  ****
+# 
+if test -z "$old_CFLAGS"; then
+  if test "x$CFLAGS" = "x-g"; then
+    CFLAGS="-O"
+  fi
+fi
+# Ptx bug workaround -- insert -lc after -ltermcap
+test -n "$seqptx" && LIBS="-ltermcap -lc -lsocket -linet -lnsl -lsec -lseq"
+
+AC_RUN_IFELSE([AC_LANG_SOURCE([[main(){return(0);}]])],,[AC_MSG_ERROR(cannot run the compiler - internal error. Sorry.)])
+
+AC_CONFIG_FILES([Makefile doc/Makefile])
+AC_CONFIG_COMMANDS([default],[[
+# a hook for preserving undef directive in config.h
+mv config.h conftest
+sed -e 's@^\(.*\)defin.\( .*\) .*/\*\(.*KEEP_UNDEF_HERE\)@\1undef\2	/\*\3@' < conftest > config.h
+rm -f conftest
+]])
+AC_OUTPUT
+
+echo ""
+if test -z "$AWK"; then
+echo "!!! Since you have no awk you must copy the files 'comm.h.dist'"
+echo "!!! and 'term.h.dist' to 'comm.h' and 'term.h'."
+echo "!!! Do _not_ change the user configuration section in config.h!"
+echo "Please check the pathnames in the Makefile."
+else
+echo "Now please check the pathnames in the Makefile and in the user"
+echo "configuration section in config.h."
+fi
+echo "Then type 'make' to make screen. Good luck."
+echo ""
